#include <fstream>
#include <windows>

#include "pngdecod.h"
#include "bmpencod.h"

using namespace std ;
extern void initBufPlus(char * name);
extern void doneBufPlus();

void Usage (int argc, char *argv [])
{
  char *program ;
  if (argc == 0)
    program = "MPngDec" ;
  else
    program = argv [0] ;

  cout << program << " [-V] inputFile.lsg outputFile.bmp" << endl ;
  cerr << " -V - information of process" << endl ;
  exit (1) ;
  return ;
}

main (int argc, char *argv [])
{ SYSTEMTIME startTime;
  GetLocalTime(&startTime);
  if (argc < 3)
    Usage (argc, argv) ;

  PngDecoder decoder ;
  for (unsigned int ii = 1 ; ii < argc - 2 ; ++ ii)
  {
    if (argv [ii][0] != '-')
      Usage (argc, argv) ;

    switch (argv [ii][1])
    {
    case 'V':
      decoder.SetVerbose (true) ;
      break ;
    default:
      Usage (argc, argv) ;
    }
  }
  //    
  int index, len=strlen(argv[argc-2]);
  for (index=len-1;index>=0;index--)
   if (argv[argc-2][index]=='.')
    break;
  if (index<0)
   index=len;
  char *name1;
  name1=new char[min(index+5,len+1)];
  memcpy(name1,argv[argc-2],index);
  memcpy(name1+index,".pls",5);
  initBufPlus(name1);
  //    
  ifstream in (argv [argc-2], ios::binary) ;
  if (! in)
  {
    cerr << "Cannot open file " << argv [argc-2] << endl ;
    return 1 ;
  }
  BitmapImage image ;
  SYSTEMTIME startTime1;
  GetLocalTime(&startTime1);
  try
  {
    decoder.ReadImage (in, image) ;
  }
  catch (exception &ee)
  {
    cout << "-----> " << ee.what () << endl ;
  }
  SYSTEMTIME endTime1;
  GetLocalTime(&endTime1);
  int i,j, height, width;
  byte g;
  doneBufPlus();

  ofstream out (argv [argc-1], ios::binary) ;
  BmpEncoder encoder ;
  try
  {
    encoder.WriteImage (out, image) ;
  }
  catch (exception &ee)
  {
    cout << ee.what () << endl ;
  }
  SYSTEMTIME endTime;
  GetLocalTime(&endTime);
  long int interval= (endTime.wHour-startTime.wHour)*60*60*1000 +
                     (endTime.wMinute-startTime.wMinute)*60*1000 +
                     (endTime.wSecond-startTime.wSecond)*1000 +
                     (endTime.wMilliseconds-startTime.wMilliseconds);
  long int interval1=(endTime1.wHour-startTime1.wHour)*60*60*1000 +
                     (endTime1.wMinute-startTime1.wMinute)*60*1000 +
                     (endTime1.wSecond-startTime1.wSecond)*1000 +
                     (endTime1.wMilliseconds-startTime1.wMilliseconds);
  cout <<endl <<interval <<" miliseconds execute." <<endl
       <<interval1 <<" miliseconds copmress." <<endl;
  return 0 ;
}
