#include "klJPEGLS.h"

int trebaInitializeMasCorectPredict=1;
int vLUT[3][2 * LUTMAX8];
int classmap[CONTEXTS1];

void initializeMasCorectPredict()
 {int i, j, idx;
  int T1=3, T2=7, T3=21;
  for (i = -LUTMAX8 + 1; i < LUTMAX8; i++)
   {if  ( i <= -T3 )        /* ...... -T3  */
     idx = 7;
    else if ( i <= -T2 )    /* -(T3-1) ... -T2 */
          idx = 5;
      	 else if ( i <= -T1 )    /* -(T2-1) ... -T1 */
	       idx = 3;
              else if ( i <= -1 )     /* -(T1-1) ...  -1 */
	            idx = 1;
	     	   else if ( i == 0 )      /*  just 0 */
		    	 idx = 0;
                        else if ( i < T1 )      /* 1 ... T1-1 */
			      idx = 2;
			     else if ( i < T2 )      /* T1 ... T2-1 */
			           idx = 4;
			          else if ( i < T3 )      /* T2 ... T3-1 */
			        	idx = 6;
			               else                    /* T3 ... */
				        idx = 8;

    vLUT[0][i + LUTMAX8] = CREGIONS * CREGIONS * idx;
    vLUT[1][i + LUTMAX8] = CREGIONS * idx;
    vLUT[2][i + LUTMAX8] = idx;
   }
  /*  prepare context mapping table (symmetric context merging) */
  classmap[0] = 0;
  for ( i=1, j=0; i<CONTEXTS1; i++)
   {int q1, q2, q3, n1=0, n2=0, n3=0, ineg, sgn;
    if(classmap[i])
     continue;
    q1 = i/(CREGIONS*CREGIONS);		/* first digit */
    q2 = (i/CREGIONS)%CREGIONS;		/* second digit */
    q3 = i%CREGIONS;    			/* third digit */
    if((q1%2)||(q1==0 && (q2%2))||(q1==0 && q2==0 && (q3%2)))
     sgn = -1;
    else
     sgn = 1;
    /* compute negative context */
    if(q1) n1 = q1 + ((q1%2) ? 1 : -1);
    if(q2) n2 = q2 + ((q2%2) ? 1 : -1);
    if(q3) n3 = q3 + ((q3%2) ? 1 : -1);
    ineg = (n1*CREGIONS+n2)*CREGIONS+n3;
    j++ ;    /* next class number */
    classmap[i] = sgn*j;
    classmap[ineg] = -sgn*j;
   }
 };

corectPredict::corectPredict()
 {if (trebaInitializeMasCorectPredict)
   {initializeMasCorectPredict();
    trebaInitializeMasCorectPredict=0;
   }
  initialize();
 };

void corectPredict::initialize()
 {for (int i = 0; i < CONTEXTS; ++i)
   {C[i]= B[i] = 0;

    N[i] = 1;
   }
 }

unsigned char corectPredict::JPEGLSPredict(unsigned char a, unsigned char b, unsigned char c, unsigned char d, unsigned char xdx, bool tupXdx)

 {int Px;

  predict(a, b, c);

  int SIGN;

  int Q = vLUT[0][d - b + LUTMAX8] +

          vLUT[1][b - c + LUTMAX8] +
          vLUT[2][c - a + LUTMAX8];
  Q = classmap[Q];

  if (Q<0)

   {SIGN=-1;

    Q = -Q;
   }
  else
   SIGN=+1;


  int Nt, Bt, Errval;


  Px = Px + (SIGN) * C[Q];

  //clip(Px,alphaJPEGLS);
  unsigned char x;
  if (tupXdx)
   x=xdx;
  else
   x=/*(unsigned char)*/Px+xdx;
  Errval = SIGN * (x - Px);
  /* Modulo reduction of predication error (A.4.5) */
  if (Errval < -ceil_half_alphaJPEGLS)
   Errval += alphaJPEGLS;
  else
   if (Errval > ceil_half_alphaJPEGLS)
    Errval -=alphaJPEGLS;
  Nt = N[Q];
  /* Do Rice mapping and compute magnitude of Errval */
  Bt = B[Q];
  /* update bias stats (after correction of the difference) (A.6.1) */
  B[Q] = (Bt += Errval);
  /* check for reset */
  if (Nt == reset)
   {N[Q] = (Nt >>= 1);
    B[Q] = (Bt >>= 1);
   }
  N[Q] = (++Nt);
  /* Do bias estimation for NEXT pixel */
  /* Bias cancelation tries to put error in (-1,0] (A.6.2)*/
  if  ( Bt <= -Nt )
   {if (C[Q] > MIN_C)
     --C[Q];
    if ( (B[Q] += Nt) <= -Nt )
     B[Q] = -Nt+1;
   }
  else
   if ( Bt >= Nt )
    {if (C[Q] < MAX_C)
      ++C[Q];
     if ( (B[Q] -= Nt) >=Nt )
      B[Q] = Nt-1;
    }
  return Px;
 }


