#include <fstream>
#include <windows.h>
#include "pngencod.h"
#include "bmpdecod.h"

using namespace std ;
unsigned long countZamina, countZaminaV, countZaminaG;
extern void writeFileBufPlus(char *name);
extern void doneBufPlus();
//extern unsigned long countFilter[FilterBufferCount];

void Progress (BitmapImageCoder &, void*, unsigned int pass, unsigned int passcount,
               unsigned int percent, bool &)
{
  unsigned int value = 100 * (pass - 1) / passcount + percent / passcount ;
  cout << value << "%                \r" << flush ;
}

void Usage (int argc, char *argv [])
{
  char *program ;
  if (argc != 0)
    program = argv [0] ;
  else
    program = "MPngEnc" ;

  cerr << "Usage: " << program << " [-I -F -M -P -R] input.bmp output.lsg" << endl ;
  cerr << " -I - information of process" << endl ;
  cerr << " -F - fasted compression" << endl ;
  cerr << " -M - maximal compression" << endl ;
  cerr << " -P - not use prediktori" << endl ;
  cerr << " -R - only LZ-blocks, oriented to replacement" << endl; // LZ-,   

  exit (1) ;
  return ;
}

main (int argc, char *argv [])
{
  SYSTEMTIME startTime;
  GetLocalTime(&startTime);

  if (argc < 3)
    Usage (argc, argv) ;

  PngEncoder encoder ;

  for (unsigned int ii = 1 ; ii < argc - 2 ; ++ ii)
  {
    if (argv [ii][0] != '-')
      Usage (argc, argv) ;

    switch (argv [ii][1])
    {
    case 'P':
      encoder.SetCompressionVertical();
      encoder.SetCompressionGorizontal();
      break ;
    case 'F':
      encoder.SetCompressionLevel (PngEncoder::FastestCompression) ;
      break ;
    case 'M':
      encoder.SetCompressionLevel (PngEncoder::MaximumCompression) ;
      break ;
    case 'I':
      encoder.SetProgressFunction (Progress, NULL) ;
      break ;
    case 'R':
      encoder.trebaOptimizeLZBlock=false;
      break ;
    default:
      Usage (argc, argv) ;
    }
  }

  ifstream input (argv [argc-2], ios::binary) ;
  if (! input)
  {
    cerr << "Can't open input file " << argv [argc-2] << endl ;
    exit (1) ;
  }

  BmpDecoder decoder ;
  BitmapImage image ;
  try
  {
    decoder.ReadImage (input, image) ;
  }
  catch (exception &ee)
  {
    cerr << ee.what () << endl ;
        throw ;
  }

  ofstream output (argv[argc-1], ios::binary) ;
  if (! output)
  {
    cerr << "Can't open output file " << argv [argc-1] << endl ;
    exit (1) ;
  }
  if (image.BitCount() != 24)
   {cerr << "Image not is True Color (24 bits)" << endl ;
    exit (1) ;
   }

  //
  SYSTEMTIME startTime1;
  GetLocalTime(&startTime1);
  try
  {
    encoder.WriteImage (output, image) ;
  }
  catch (exception &ee)
  {
    cerr << ee.what () << endl ;
  }
  SYSTEMTIME endTime1;
  GetLocalTime(&endTime1);
  //   
  int index, len=strlen(argv[argc-1]);
  for(index=len-1;index>=0;index--)
   if (argv[argc-1][index]=='.')
    break;
  if (index<0)
   index=len;
  char *name1;
  name1=new char[min(index+5,len+1)];
  memcpy(name1,argv[argc-1],index);
  memcpy(name1+index,".pls",5);
  writeFileBufPlus(name1);
  doneBufPlus();
  SYSTEMTIME endTime;
  GetLocalTime(&endTime);
  long int interval= (endTime.wHour-startTime.wHour)*60*60*1000 +
                     (endTime.wMinute-startTime.wMinute)*60*1000 +
                     (endTime.wSecond-startTime.wSecond)*1000 +
                     (endTime.wMilliseconds-startTime.wMilliseconds);
  long int interval1=(endTime1.wHour-startTime1.wHour)*60*60*1000 +
                     (endTime1.wMinute-startTime1.wMinute)*60*1000 +
                     (endTime1.wSecond-startTime1.wSecond)*1000 +
                     (endTime1.wMilliseconds-startTime1.wMilliseconds);
  cout <<endl <<interval <<" miliseconds execute." <<endl
       <<interval1 <<" miliseconds copmress." <<endl
       <<"Zamineno: "<< countZamina+countZaminaV+countZaminaG
       <<" (" <<countZamina <<" S + " <<countZaminaV << " V + " <<countZaminaG <<" G)" <<endl ;
  return 0 ;
}
